# Code Server for WPILIB

This project provides Dockerfiles that can be used to create container images that serve a web based version of the VSCode programming environment for WPILIB programming. 

This is NOT a replacement for a decent programming computer for your build space (see the Caveats section), but more a way to provide the ability to program to students who may not have access to a computer where they are allowed to install software (school computers, family computers, etc.)

### Getting Started

You have to built the container images yourself before you can start. (See the Why Don't You Provide the Container Images? section for why). 

You need to select which overarching distro you want the container to be based on. For most users this isn't super important, but the option is there for those who care. There are currently two stable options:

- Dockerfile.ubuntu (which is likely what most people will want, as it'll be very similar to existing experiences with distros like Raspberry Pi OS)
- Dockerfile.fedora (for those in the community who prefer/are familar with RHEL/OracleLinux or similar)

1. Install [Docker](https://docs.docker.com/engine/install/)
2. Open your terminal of choice
3. Clone this project using git, and "cd" to the cloned folder
4. Run the following command
```docker build --build-arg WPILIB_DL_URL=<DL_URL> -f <DockerFile> -t code-server-wpilib:latest .```
The <DL_URL> should be the Linux image appropriate to your platform from the [releases page](https://github.com/wpilibsuite/allwpilib/releases). The <DockerFile> will either be Dockerfile.ubuntu or Dockerfile.fedora
5. Start an instance of the container ```docker run -d -p 8080:8080 --name <instance_name> code-server-wpilib:latest```

